/* Default linker script, for normal executables */
OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)
ENTRY("_main")
MEMORY
{
	ram     : o = 0x0000, l = 0x3000
}
SECTIONS
{
.text :
	{
	  LONG ( ABSOLUTE (_main) )
	  *(.text)
   	   _etext = . ;
	}  > ram
.data :
	{
	  *(.data)
	  *(.rodata) 
	  *(.strings)
	  *(.tiny)
	   _edata = . ;
	}  > ram
.bss :
	{
	   _bss_start = . ;
	  *(.bss)
	  *(COMMON)
	   _end = . ;
	}  >ram
}
