#include "../sysinfo/src/incl/plugin.h"
#include "../sysinfo/src/incl/3069S.H"

#define EXTIO_DDRA   (*(volatile unsigned char   *)0x600000) /* P1DDR Address*/
#define EXTIO_DRA    (*(volatile unsigned char   *)0x600001) /* P1DDR Address*/
#define EXTIO_DDRB   (*(volatile unsigned char   *)0x600002) /* P1DDR Address*/
#define EXTIO_DRB    (*(volatile unsigned char   *)0x600003) /* P1DDR Address*/
#define EXTIO_DDRC   (*(volatile unsigned char   *)0x600004) /* P1DDR Address*/
#define EXTIO_DRC    (*(volatile unsigned char   *)0x600005) /* P1DDR Address*/

#define INTERVAL	(60*60)


int main(int argc, char **argv){
	UW dat;


	dat = get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat /= 5;

	// 200lx : 100uA  -> 200lx : 100mV => 2000 [lx/V]

	// ŌvZ
	//    dat*5/1024 [V] * 2000 [lx/V]
	dat = (dat * 5 * 2000) / 1024;

	if( time()%INTERVAL == 0 ){
		if( (dat >= 50) && ((W)vs1011e_getplayID() < 0)){
			print("playing");
			vs1011e_play("/alarm.mp3");
		}
	}

	return 0;
}


