#ifndef _EXEC_H_
#define _EXEC_H_



#ifndef _MACRO_ONLY


#define EXEC_IO_SERIAL	0
#define EXEC_IO_FILE	1
#define EXEC_IO_NETWORK	2


#endif	/* of #ifndef _MACRO_ONLY */

struct program_io{
	W	std_in;
	W	std_out;
	W	std_err;

	UB io_mux_in :2;
	UB io_mux_out:2;
	UB io_mux_err:2;
	UB :2;
};

struct env{
	char *name;
	char *val;
	UH maxvalsize;		// val ɊmۂĂoCg
};

UB exec_init(void);
W  exec(char *file, UB *buf, UW bufsiz, struct program_io *pio, int argc, char **argv, int *res);
W  exec2(UB *buf, struct program_io *pio, int argc, char **argv, int *res);

W  exec_print    (B *buf);
W  exec_print2   (B *buf, W len);
W  exec_errprint (B *buf);
W  exec_errprint2(B *buf, W len);
W  exec_scan     (B *buf, W len);
W  exec_scan_tmout(B *buf,W len, W tmo);

B     install_env(struct env *e);
char *get_env(char *name);
B     set_env(char *name, char *val);

#endif	/* of #ifndef _EXEC_H_ */
