#ifndef _FAT_API_H_
#define _FAT_API_H_

#include "fatdatatype.h"

struct dirent{
	UB	attr;			/* fBNgGg̑
					    ATTR_READ_ONLY	0x01
					    ATTR_HIDDEN		0x02
					    ATTR_SYSTEM		0x04
					    ATTR_VOLUME_ID	0x08
					    ATTR_DIRECTORY	0x10
					    ATTR_ARCHIVE	0x20

					    ATTR_LONG_NAME	0x0f
					*/
	UB	d_name[NAME_MAX+1];	/* NULL ^[~l[gꂽfBNgGg
					  t@C̓rɃXy[XȂ
					   "HOGE    .TXT"Ƃ͂A"HOGE.TXT"̂悤ɓrɃXy[X͓Ȃ
					   gqȂꍇ́A؂'.'tȂB
					*/
};

typedef struct dirent dirent;

struct DIR {
	UH	offset;		// fBNgXg[̃ItZbgԍ(擪̃fBNgGgŕ\)
	UW	cluster;	// fBNgXg[̐擪NX^
	dirent	entry;		// fBNgGg(readdirȂǂŖ߂lƂdirent߂Kv邽߁A̋L)
	UB	isValid;	// 0 : (pĂȂ),  : ُ(t@Cꂽ),  : 
};

typedef struct DIR DIR;

struct stat {
	UB	st_mode;    //  (ATTR_READ_ONLYȂǂ)
	UW	st_size;    // Ŝ̃TCY (oCgP)

	UW	st_atime;   // ŏIANZX
	UW	st_mtime;   // ŏIC
	UW	st_ctime;   // 쐬
};




// open 
#define O_RDONLY	1
#define O_WRONLY	2
#define O_RDWR 		4

#define O_DIRFILE	16

// lseek 
#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2







B  open  (const char *pathname, W flags);
B  creat (const char *pathname, UH mode);
B  unlink(const char *pathname);
B  close(UB fd);
W  read (UB fd, UB *buf, W count);
W  write(UB fd, UB *buf, W count);
W  lseek(UB fildes, W offset, W whence);

DIR           *opendir(const char *pathname);
struct dirent *readdir(DIR *dir);
B             closedir(DIR *dir);

B rmdir(const char *pathname);
B mkdir(const char *pathname, UH mode);

B stat (const char *fname, struct stat *buf);
B fstat(UB fd, struct stat *buf);

B diskfree(UW *total, UW *free);

#endif	/* of #ifndef _FAT_API_H_ */


