#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdesc.h"
#include "mmc_config.h"


extern FileDesc FD[];



/*

t@C̏Ԃ擾

:
	fd : Ώۃt@C̃t@CfXNv^

߂l:
	ꍇɂ 0 Ԃ

*/
B fstat(UB fd, struct stat *buf){

	if( fd >= N_FILE_DESCRIPTER ) return -1;
	if( ! FD[fd].isValid        ) return -1;

	buf->st_mode = FD[fd].v->d.attribute;
	buf->st_size = FD[fd].v->size;


	struct tm tmc;
	DirEntry *p = &(FD[fd].v->d);

	//-----------------------------
	UH time = p->createTime[0] | ((p->createTime[1])<<8);
	UH date = p->createDate[0] | ((p->createDate[1])<<8);

	tmc.tm_sec  = (p->createTimeMs/100) + ((time&0xf)<<1);
	tmc.tm_min  = (time>>5) & 0x3f;
	tmc.tm_hour =  time>>11;
	tmc.tm_mday =   date    & 0x1f;
	tmc.tm_mon  = ((date>>5)& 0x0f) - 1; 	// 1ȗ̌ (0..11)
	tmc.tm_year = ((date>>9)& 0x7f) + 80;	// 1900Nȗ̔N
	tmc.tm_wday = 0;			// 0j@1j ... (0..6)
	tmc.tm_yday = 0;			// 11ȗ̓(0..365)
	tmc.tm_isdst= 0;			// ĎԂ̃tO
	
	buf->st_ctime = mktime(&tmc) + TIMEZONE;
	
	//-----------------------------
	time = p->writeTime[0] | ((p->writeTime[1])<<8);
	date = p->writeDate[0] | ((p->writeDate[1])<<8);
	
	tmc.tm_sec  = (time&0xf)<<1;
	tmc.tm_min  = (time>>5) & 0x3f;
	tmc.tm_hour =  time>>11;
	tmc.tm_mday =   date    & 0x1f;
	tmc.tm_mon  = ((date>>5)& 0x0f) - 1; 	// 1ȗ̌ (0..11)
	tmc.tm_year = ((date>>9)& 0x7f) + 80;	// 1900Nȗ̔N
	tmc.tm_wday = 0;			// 0j@1j ... (0..6)
	tmc.tm_yday = 0;			// 11ȗ̓(0..365)
	tmc.tm_isdst= 0;			// ĎԂ̃tO
	
	buf->st_mtime = mktime(&tmc) + TIMEZONE;
	
	//-----------------------------
	date = p->accessDate[0] | ((p->accessDate[1])<<8);
	
	tmc.tm_sec  = 0;
	tmc.tm_min  = 0;
	tmc.tm_hour = 0;
	tmc.tm_mday =   date    & 0x1f;
	tmc.tm_mon  = ((date>>5)& 0x0f) - 1; 	// 1ȗ̌ (0..11)
	tmc.tm_year = ((date>>9)& 0x7f) + 80;	// 1900Nȗ̔N
	tmc.tm_wday = 0;			// 0j@1j ... (0..6)
	tmc.tm_yday = 0;			// 11ȗ̓(0..365)
	tmc.tm_isdst= 0;			// ĎԂ̃tO
	
	buf->st_atime = mktime(&tmc) + TIMEZONE;

	return 0;
}


