#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatbase.h"
#include "fatdesc.h"


/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;


/*
MMCɃt@C݂邩TB
ꍇɂ́At@C̏߂̃NX^ԍƃt@CTCY߂B
512 byte̍ƗpƂė^KvB

t@CT̓Ot@Cl[ɑΉĂȂB

:
	pathname : Jt@C
	flags    : O_RDONLY, O_WRONLY, O_RDWR ̂ǂꂩƕʂ̃IvVORĎw肷

߂l: t@Cꍇɂ̓t@CfBXNv^ԂB
        sꍇɂ-1ԂB

*/
B open(const char *pathname, W flags){

	DirEntryPos filepos, parentpos;
	UB attr, buf[512];
	B  ret = -1;
	UB  opt;

	opt   = flags & 0xf0;
	flags = flags & 0x0f;

	if( flags!=O_RDONLY && flags!=O_WRONLY && flags!=O_RDWR ) return -1;
	if( flags!=O_RDONLY && (opt&O_DIRFILE) ) return -1;


	if(*pathname=='/') pathname++;

	wai_sem( FAT_SEM );


	if( lookUpDirEntry(pathname, LOOKUP_DIRENTRY_FILEDIR, buf, &filepos, &parentpos) < 0 ) goto err_exit;

	attr = getAttrAtDirEntry( (DirEntry *)(buf+(filepos.offset<<5)) );

	// fBNg͖ݒ̂Ƃ́AfBNgOpenĂ͂Ȃ
	if( !(opt&O_DIRFILE) && (attr&ATTR_DIRECTORY) )  goto err_exit;

	// ݉\ŊJ悤ƂAREAD only 
	if( (flags != O_RDONLY) && (attr&ATTR_READ_ONLY) ) goto err_exit;
	// ǂݍ݉\ŊJ悤ƂAHidden 
	if( (flags != O_WRONLY) && (attr&ATTR_HIDDEN   ) ) goto err_exit;



	//  fd Ȃ -1 ݒ肳
	if( (ret = lookupFreeFD()) < 0 ) goto err_exit;

	syslog(LOG_NOTICE, "File %s found (fd:%d, DirEntry cluster:%d sector:%d offset:%d)", pathname, ret, filepos.cluster, filepos.sector, filepos.offset);

	//         fd, Flags, offset,      de_cluster,      de_sector,           de_offset,  dir entry
	settingFD(ret, flags,      0, filepos.cluster, filepos.sector, (filepos.offset<<5), (DirEntry *)(buf+(filepos.offset<<5)));

err_exit:

	sig_sem( FAT_SEM );
	return ret;			// ret -1ŏĂ
}


