#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatbase.h"
#include "mmc_access.h"


/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;

extern UW secPerCluster;

/*
fBNgGgǂݏoB
(ƁAlong file name ̃fBNgGg͓ǂݔ΂)


:   fBNgGgǂݏofBNg

߂l: fBNgGgBsƂɂNULL
        ł̊֐ĂяoƁA߂l͏㏑B

*/
struct dirent *readdir(DIR *dir){

	B  eflag;
	UB tmp[512],i;
	UH sec, byte, k;
	UW cluster, depth;
	dirent *res = NULL;
	
	if( dir == NULL ) return NULL;
	if( card_status & (MMC_CARD_NOTINSERTED | MMC_CARD_NOT_INIT | MMC_CARD_NOT_FSINIT) ) return NULL;

	wai_sem( FAT_SEM );

	if( dir->isValid <= 0 ) goto exit;


	cluster = dir->cluster;

	// ǂݎ擪̈ʒu
	// : (dir->offset<<5) >> 9 = dir->offset>>4 (offsetڂ̃fBNgGgi[ĂZN^̃ItZbg)
	depth  = (dir->offset >> 4) / secPerCluster;	// NX^̐[
	sec    = (dir->offset >> 4) % secPerCluster;
	byte   = (dir->offset & 0xf) <<5;		// 1ZN^ɓ̂ 16 fBNgGgB

	// ǂݎ擪NX^T
	for(k=0; k < depth; k++){
		if( 1 == (cluster = lookup_nextcluster(cluster))) goto exit;
	}

	do{
		if( (eflag = readCluster(&cluster, &sec, tmp)) < 0 ) goto exit;

		for( ; byte < 512; byte+= 32){
			dir->offset ++;

			// 󂾂ApĂȂt@C΂
			if( 0 == tmp[byte] || 0x05 == tmp[byte] || 0xe5 == tmp[byte]) continue;

			// long file name ̃Ggꍇɂ͔΂
			if( tmp[byte+11] == 0x0f ) continue;

			(dir->entry).attr = getAttrAtDirEntry((DirEntry *)(tmp+byte));

			for(k=0,i=0; k<11; k++){
				if( k<8 && tmp[byte+k] ==' ' ){
					k = 7; continue;
				}
				if( k>=8 && tmp[byte+k] ==' ' ){
					break;
				}
				if( k==8 && tmp[byte+k] !=' '){
					(dir->entry).d_name[i++] = '.';
				}
				(dir->entry).d_name[i++] = tmp[byte+k];
			}
			(dir->entry).d_name[i] = '\0';

			res = &(dir->entry);

			break;
		}
		
		if( byte < 512 ) break;
		byte = 0;
	}while(!eflag);

exit:
	sig_sem( FAT_SEM );

	return res;
}


