#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdesc.h"
#include "fatbase.h"
#include "mmc_access.h"

extern FileDesc	FD[];

/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;

extern UW secPerCluster;

/*
g writeCluster sƏȂ̂ŗӁB
(writeClusterł͎̏ݗp̃NX^̊mۂsÂƂNX^̊mۂłȂƂ0ȊO̒l(1)ԂB
̏ꍇ߂Ă(݂̏Ŗ{̈ӖŎs)B)

l̗R readCluster ɂ͎gȂB
Ō̃NX^̍Ō̃ZN^ǂ񂾂Ƃ1Ԃ߁B
*/
#define CHECK_IO(x)	if( 0 != x ){ syslog(LOG_NOTICE,"write:%d: i/o error", __LINE__); count = -1; goto exit; }

/*

fd ő count oCgǂݏoAbufɊi[B

߂l: ꍇɂ͓ǂݍ񂾃oCgԂBAt@C̏Ił0ɂȂB
	t@Cʒu͂̐i߂(lseek)B
	t@C̍Ōɋ߂ꍇɂ́Acount߂lɂȂ邱ƂB
	G[̏ꍇ -1 ԂB
*/
W write(UB fd, UB *buf, W count){
	UB tmp[512];
	W  k, i, size, count0, count1, byte;
	UW cluster, depth;
	UH sec;
	UW wpos;
	
	if( fd >= N_FILE_DESCRIPTER ) return -1;
	if(count < 0) return -1;
	if( card_status & (MMC_CARD_NOTINSERTED | MMC_CARD_NOT_INIT | MMC_CARD_NOT_FSINIT) ) return -1;


	wai_sem( FAT_SEM );

	if(FD[fd].isValid == 0 || FD[fd].flags == O_RDONLY){
		count = -1; goto exit;
	}

	cluster = FD[fd].v->cluster;
	size    = FD[fd].v->size;

	// syslog(LOG_NOTICE, "File size %d, cluster %d, offset %d", size, cluster, FD[fd].offset);
	
	if( cluster == 0 ){
		// NX^mۂłȂꍇɂ͎s
		if( 1 == (cluster = alloc_nextcluster(0)) ){ count = -1; goto exit; }
		FD[fd].v->cluster = cluster;
		setClusterAtDirEntry(&(FD[fd].v->d), cluster);

		FD[fd].v->cluster_depth = 0;
		FD[fd].v->cluster_cache = cluster;
	}
	
	
	// ݃oCg(0̏ݐ)
	count0 = (FD[fd].offset-size > 0) ? FD[fd].offset - size : 0;
	
	// ݃oCg(buf ̓e)
	count1 = count;
	
	
	// ސ擪̈ʒu
	wpos = (FD[fd].offset > size) ? size : FD[fd].offset;
	depth  = (wpos>>9) / secPerCluster;
	sec    = (wpos>>9) % secPerCluster;
	byte   = wpos & 0x1ff;

	// ݐ擪NX^T
	if( depth == FD[fd].v->cluster_depth ){
		cluster = FD[fd].v->cluster_cache;
	}else{
		if( depth > FD[fd].v->cluster_depth ){
			cluster = FD[fd].v->cluster_cache;
			for(k=FD[fd].v->cluster_depth; k < depth; k++){
				if( 1 == (cluster = lookup_nextcluster(cluster))){ count = -1; goto exit; }
			}
		}else{
			for(k=0; k < depth; k++){
				if( 1 == (cluster = lookup_nextcluster(cluster))){ count = -1; goto exit; }
			}
		}
		FD[fd].v->cluster_depth = depth;
		FD[fd].v->cluster_cache = cluster;
	}

	if( byte != 0 ){ CHECK_IO(readSector(cluster, sec, tmp)) }

	// 0 ̏
	for(k=0; k < count0; k++){
		if( byte == 0 && (count0-k) >= 512 ){
			for(i=0; i<512; i++) tmp[i] = 0;

			CHECK_IO( writeCluster(&cluster, &sec, tmp) )
			k += 511;
		}else{
			if( byte == 0 ){
				CHECK_IO( readSector(cluster, sec, tmp) )
			}
			tmp[byte++] = 0;
			if( byte == 512 ){
				byte = 0;

				CHECK_IO( writeCluster(&cluster, &sec, tmp) )
			}
		}
	}

	// f[^̏
	for(k=0; k < count1; k++){
		if( byte == 0 && (count1-k) >= 512 ){
			UH wcount = (count1-k)>>9;
			
			CHECK_IO( writeClusterM(&cluster, &sec, buf, wcount) )
			buf = ((UB *)buf)+(wcount<<9);
			k += (wcount<<9)-1;
		}else{
			if( byte == 0 ){
				CHECK_IO( readSector(cluster, sec, tmp) )
			}
			tmp[byte++] = *((UB *)buf)++;
			if( byte == 512 ){
				byte = 0;

				CHECK_IO( writeCluster(&cluster, &sec, tmp) )
			}
		}
	}
	if( byte != 0 ){
		CHECK_IO( writeCluster(&cluster, &sec, tmp) )
	}

	FD[fd].offset += count0+count1;

	size = FD[fd].offset > size ? FD[fd].offset : size;
	FD[fd].v->size = size;

	if(! FD[fd].v->erase ){
		// DirEntry ̍XV
		setDirectryEntry(
			&(FD[fd].v->d),	// fBNgGg
			DE_CHANGE_SIZE | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,		// 
			NULL,		// t@C
			0,		// Attribute 
			0,		// cluster
			size );		// Size

		CHECK_IO( writeDirEntry(&(FD[fd].v->d), FD[fd].v->de_cluster, FD[fd].v->de_sector, FD[fd].v->de_offset ) )
	}

exit:
	sig_sem( FAT_SEM );

	return count;
}


