#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"


#include "fataccs.h"
#include "fat32.h"
#include "fat16.h"
#include "fat12.h"

/*
fatio.c Œ`

FAT12 ... 12
FAT16 ... 16
FAT32 ... 32
*/
extern UB FATSize;	// FAT12, FAT16, FAT32 ?


UB FAT_cache[512];
W  FAT_cache_sec = -1;



void flush_FATcache(void){
	FAT_cache_sec=-1;
}



/*
ŗ^ꂽNX^̎̃NX^ԂB

sƂ1Ԃ
~~~~~~~~~~~~~~~~~~~~~
*/
UW   lookup_nextcluster(UW cluster){

	if(FATSize == 16){
		return fat16_lookup_nextcluster(cluster);
	}else if(FATSize == 32){
		return fat32_lookup_nextcluster(cluster);
	}else if(FATSize == 12){
		return fat12_lookup_nextcluster(cluster);
	}

	return 1;
}

/*

s畉̒lԂB
0
*/
B freeClusterChain(UW cluster){

	if(FATSize == 16){
		return fat16_freeClusterChain(cluster);
	}else if(FATSize == 32){
		return fat32_freeClusterChain(cluster);
	}else if(FATSize == 12){
		return fat12_freeClusterChain(cluster);
	}

	return -1;
}


/*
ŗ^ꂽNX^ŌNX^ɂB

s畉̒lԂB
0
*/
B terminateCluster(UW cluster){

	if(FATSize == 16){
		return fat16_terminateCluster(cluster);
	}else if(FATSize == 32){
		return fat32_terminateCluster(cluster);
	}else if(FATSize == 12){
		return fat12_terminateCluster(cluster);
	}

	return -1;
}

/*
ŗ^ꂽNX^́ÃNX^mۂA
`FCB


Ƃ 0 ^ꂽꍇɂ́A擪̃NX^mۂB
NX^̊mۂɎsꍇɂ1Ԃ
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ꍇɂ͊mۂ̃NX^Ԃ
*/
UW   alloc_nextcluster(UW cluster){

	if(FATSize == 16){
		return fat16_alloc_nextcluster(cluster);
	}else if(FATSize == 32){
		return fat32_alloc_nextcluster(cluster);
	}else if(FATSize == 12){
		return fat12_alloc_nextcluster(cluster);
	}

	return 0;
}
