#ifndef _FATDIRENTRY_H_
#define _FATDIRENTRY_H_

struct DirEntryPos{
	UW	cluster;
	UH	sector;
	UB	offset;
	B	isValid;	// 0ȊO: L, 0: 
};

typedef struct DirEntryPos DirEntryPos;

char strncmp2(const char *s, const char *t, char n);

const char *getCurDirName(const char *name, char *nname, B *isDir);



#define LOOKUP_DIRENTRY_FILE	1	// Ŏw肷t@C̃fBNgGgT
					// (t@CȂƂ͎s)

#define LOOKUP_DIRENTRY_CREAT	2	// Ŏw肷t@C̃fBNgGgT
					// ȂƂ͋󂫃Gg߂
					// 󂫃Gg̓fBNgGg̐擪ɍł߂̂mۂ
					// (󂫂ȂƂ͎s)

#define LOOKUP_DIRENTRY_FILEDIR	4	// Ŏw肷fBNgGgT
					// (fBNgłt@Cł悢)
B lookUpDirEntry(const char *path, UB mode, UB *buf, DirEntryPos *de, DirEntryPos *par);



#define DE_CHANGE_NAME		(1<<0)
#define DE_CHANGE_ATTR		(1<<1)
#define DE_CHANGE_CLUSTER	(1<<2)
#define DE_CHANGE_SIZE		(1<<3)
#define DE_CHANGE_CRETIME	(1<<4)
#define DE_CHANGE_ACCDATE	(1<<5)
#define DE_CHANGE_WRITIME	(1<<6)

void setDirectryEntry(DirEntry *d, UB mode, char *name, UB attr, UW cluster, UW size);

B    writeDirEntry(DirEntry *d, UW de_cluster, UH de_sector, UH de_offset);

UW   getClusterAtDirEntry(DirEntry *d);
UB   getAttrAtDirEntry   (DirEntry *d);
void setClusterAtDirEntry(DirEntry *d, UW cluster);


#endif	/* of #ifndef _FATDIRENTRY_H_ */

