#ifndef _MMC_ACCESS_H_
#define _MMC_ACCESS_H_

#include "mmc_config.h"

#define MMC_CARDCHECK_PRIORITY		6
#define MMC_CARDCHECK_STACK_SIZE	1024



#define MMC_CARD_NOTINSERTED	1
#define MMC_CARD_NOT_INIT	(1<<1)		/* ܂ĂȂ */
#define MMC_CARD_NOT_FSINIT	(1<<2)		/* FSR/W̏ĂȂ */


#ifndef _MACRO_ONLY

void mmc_cardcheck_task(VP_INT exinf);
void mmc_enable_hotplug(void);

UB mmc_getCID(UB *buf);
UB mmc_getCSD(UB *buf);
UB mmc_read  (UW sec, UB *buf);
UB mmc_write (UW sec, UB *buf);
UB mmc_write_multiple(UW sec, UB *buf, UB count);
UB mmc_init  (void);


#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _MMC_ACCESS_H_ */
