#ifndef _MMC_IO_H_
#define _MMC_IO_H_

#define MMC_BIT_nCS		3
#define MMC_BIT_CLK		5
#define MMC_BIT_VIN		6
#define MMC_BIT_RVOUT		7
#define MMC_BIT_nCARDINSERT	2
#define MMC_BIT_nCARDACTLED	1

#define MMC_nCS			(1<<MMC_BIT_nCS)
#define MMC_CLK			(1<<MMC_BIT_CLK)
#define MMC_VIN			(1<<MMC_BIT_VIN)

#define MMC_RVOUT		(1<<MMC_BIT_RVOUT)

#define MMC_nCARDINSERT		(1<<MMC_BIT_nCARDINSERT)
#define MMC_nCARDACTLED		(1<<MMC_BIT_nCARDACTLED)

#define MMC_ENABLE_CS		(PBDR.BYTE &= (0xff - MMC_nCS))
#define MMC_DISABLE_CS		(PBDR.BYTE |= MMC_nCS)

#define MMC_INSERTED		(MMC_nCARDINSERT^(PBDR.BYTE&MMC_nCARDINSERT))
#define MMC_CARDACTLED_ON	(PBDR.BYTE &= (0xff-MMC_nCARDACTLED))
#define MMC_CARDACTLED_OFF	(PBDR.BYTE |= MMC_nCARDACTLED)


#ifndef _MACRO_ONLY


#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _MMC_IO_H_ */

