#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <time.h>

#include <net/net.h>
#include <netinet/in.h>
#include <netinet/in_itron.h>

#include "ntp.h"

// NTP Ŏ擾ƁÂƂ̃VXe^C
static SYSTIM		base_tim;
static unsigned int	trans_sec=0;		// Transmit Timestamp @ NTP
static unsigned int	trans_frac;		// Transmit Timestamp @ NTP

static volatile unsigned int sntp_interval  = 1000*60*60;	// NTPł̎킹̎@[msec]


#define UDP_BUF_SIZE		64
static  UW			udp_buf[UDP_BUF_SIZE/sizeof(UW)];
#define NTP_RCV_TIMEOUT		3

#define TO_EPOCH	2208988800U		// 1900 1/1  1970 1/1 ܂ł̕b


/*
 *  O֐̒`
 */

extern const char *itron_strerror (ER ercd);


UW get_ntp_basetime(void){
	return trans_sec;
}

void sntp_reflesh_task (VP_INT exinf){
	while(TRUE){

		do{
			fetch_ntp_time((ID)exinf);
			fetch_ntp_time((ID)exinf);
		}while(get_ntp_basetime() == 0);

		dly_tsk(sntp_interval);
	}
}

/*
NTPœԂƂԂ擾

߂l: 1970/1/1(GMT)Ƃ

*/
UW get_ntp_time(void){
	SYSTIM	now_tim;

	// Z}t@̊m
	wai_sem( NTP_SEM );

	// ݎ̎擾
	get_tim(&now_tim);
	UW time = trans_sec  + (-base_tim + now_tim)/1000 - TO_EPOCH;

	sig_sem( NTP_SEM );

	return time;
}

void fetch_ntp_time(ID cepid){

	static UB addr[sizeof("123.123.123.123")];
	T_IPV4EP dst;
	time_t	 tim;
	ER_UINT	 len;
	volatile char i;

	dst.ipaddr = 0x82220b75;	/* ntp1.tohoku.ac.jp (130.34.11.117) */
	dst.portno = 123;		/* NTP port */

	for(i=0;i<48;i++) ((UB *)udp_buf)[i]=0;
	((UB *)udp_buf)[0] = 11;

	len         = 48;
	ip2str(addr, &dst.ipaddr);
	syslog(LOG_NOTICE, "[NTP] sending to:    %s.%d, len: %d", addr, dst.portno, len);

	if ((int)(len = udp_snd_dat(cepid, &dst, (VP)udp_buf, len, TMO_FEVR)) < 0){
		syslog(LOG_NOTICE, "[NTP] error: %s", itron_strerror(len));
	}

	// Z}t@̊m
	wai_sem( NTP_SEM );
	if ((int)(len = udp_rcv_dat(cepid, &dst, (VP)udp_buf, len, NTP_RCV_TIMEOUT*1000)) >= 0) {

		// ̐ݒ
		get_tim(&base_tim);
		trans_sec  = *((unsigned int *)(((UB *)udp_buf)+40));
		trans_frac = *((unsigned int *)(((UB *)udp_buf)+44));

		// ŃZ}t@̉
		sig_sem( NTP_SEM );

		ip2str(addr, &dst.ipaddr);
		syslog(LOG_NOTICE, "[NTP] received from: %s.%d, len: %d msg: %u",
		                   addr, dst.portno, len, trans_sec );
	}else{
		// ŃZ}t@̉
		sig_sem( NTP_SEM );

		syslog(LOG_NOTICE, "[NTP] error: %s", itron_strerror(len));

		udp_can_cep(cepid, TFN_UDP_RCV_DAT);	// YƁA̎sŎs
	}
}
