#include <itron.h>
#include <s_services.h>
#include <t_services.h>
#include "tokenize.h"
#include "fat_api.h"

#include <string.h>
#include <stdio.h>


/*

name, passwd Ƃ31ȓ


ꍇ 0 ԂB
-3 : F؎s
-2 : file not found
-1 : syntax error

`(Rggp\)
--------------------------
user     (userA󔒂Ȃǂꍇɂ""Ŋ) : (pX[hA󔒂Ȃǂꍇɂ""Ŋ)
--------------------------


--------------------------

user      hoge : test1	// [U hoge ̃pX[h test1 

--------------------------
(sĂv)

*/
B checkHTTPAuthentication(B fd, char *auth){
	B user[32];
	B pass[32];
	B buf[64];
	UH token;
	UH  nval;

	while( (token = nextToken(fd, &nval, buf, sizeof(buf))) != TT_EOF ){
		if(token==TT_WORD && !strcmp(buf, "user")){
			if( nextToken(fd, &nval, user, sizeof(user)) != TT_WORD ) goto err;

			if( nextToken(fd, &nval,  buf,  sizeof(buf)) != ':'     ) goto err;
			
			if( nextToken(fd, &nval, pass, sizeof(pass)) != TT_WORD ) goto err;

			sprintf(buf,"%s:%s",user, pass);
			
			if( ! strcmp(auth, buf) ){
				return 0;
			}
		}else{
			goto err;
		}
	}

	return -3;

err:
	return -1;
}

/*

domain , passwd Ƃ128ȓ


ꍇ 0 ԂB
-2 : file not found
-1 : syntax error

`(Rggp\)
--------------------------
domain   (domainA󔒂Ȃǂꍇɂ""Ŋ)
password (pX[hA󔒂Ȃǂꍇɂ""Ŋ)
--------------------------

*/
B lookupDDNSsetting(const char *file, char *domain, UB dlen, char *passwd, UB plen){
	B fd;
	B buf[16];
	UH token;
	UH  nval;

	*domain=*passwd='\0';

	if( (fd = open(file, O_RDONLY)) < 0 ) return -2;

	while( (token = nextToken(fd, &nval, buf, sizeof(buf))) != TT_EOF ){
		if(token==TT_WORD && !strcmp(buf, "domain")){
			if( nextToken(fd, &nval, domain, dlen) != TT_WORD ) goto err;

		}else if(token==TT_WORD && !strcmp(buf, "password")){
			if( nextToken(fd, &nval, passwd, plen) != TT_WORD ) goto err;
		}else{
			goto err;
		}
	}

	close(fd);
	return 0;

err:
	close(fd);
	return -1;
}
/*



ꍇ 0 ԂB
-2 : file not found
-1 : syntax error

`(Rggp\)
--------------------------
ip  xxx.xxx.xxx.xxx
mask yyy.yyy.yyy.yyy
gw zzz.zzz.zzz.zzz
ns vvv.vvv.vvv.vvv
--------------------------

G[ƂȂ炸ɖ`ڂ́AlύXꂸɐI

*/
B lookupIPsetting(const char *file, UW *ip, UW *mask, UW *gw, UW *ns){
	B fd;
	B buf[16];
	UH token;
	UH  nval;

	if( (fd = open(file, O_RDONLY)) < 0 ) return -2;

	while( (token = nextToken(fd, &nval, buf, sizeof(buf))) != TT_EOF ){
		if(token==TT_WORD && !strcmp(buf, "ip")){
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ip = nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ip = (*ip<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ip = (*ip<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ip = (*ip<<8) | nval;
		}else if(token==TT_WORD && !strcmp(buf, "gw")){
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*gw = nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*gw = (*gw<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*gw = (*gw<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*gw = (*gw<<8) | nval;
		}else if(token==TT_WORD && !strcmp(buf, "mask")){
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*mask = nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*mask = (*mask<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*mask = (*mask<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*mask = (*mask<<8) | nval;
		}else if(token==TT_WORD && !strcmp(buf, "ns")){
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ns = nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ns = (*ns<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ns = (*ns<<8) | nval;

			if( nextToken(fd, &nval, buf, sizeof(buf)) != '.'       ) goto err;
			if( nextToken(fd, &nval, buf, sizeof(buf)) != TT_NUMBER ) goto err;
			*ns = (*ns<<8) | nval;
		}else{
			goto err;
		}
	}
	close(fd);
	return 0;

err:
	close(fd);
	return -1;
}


