#ifndef _SPI_H_
#define _SPI_H_

#include "3069S.h"
#include "mmc_config.h"


// VIN (RVOUT) ͋@푤猩̕Ȃ̂ŁA
// }CRł͏o()

#define BIT_CLK		5
#define BIT_VIN		6
#define BIT_RVOUT	7

#define nCS		(1<<BIT_nCS)
#define CLK		(1<<BIT_CLK)
#define VIN		(1<<BIT_VIN)


#define MMC_IO_TRANSMIT_SINGLE_BLOCK	1
#define MMC_IO_TRANSMIT_MULTI_BLOCK	2


#ifndef _MACRO_ONLY


UB   spi_receive          (void);
UB   spi_receive_mmcblock (UB *data, UH len);
void spi_transmit         (UB dat);
UB   spi_transmit_block   (UB *data, UH len);
UB   spi_transmit_mmcblock(UB *data, UH len, UB mode);
void spi_send_clock       (void);
UB   spi_mmcbusywait      (void);
UB   spi_init             (void);


#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _SPI_H_ */

