#include "incl/plugin.h"
#include "incl/3069S.H"



#define   EXPENSE_FILE	"kakeibo.log"

int main(int argc, char **argv){
	char year[6];
	char month[4];
	char date[4];
	char money[10];
	char target[256];
	char place [256];
	char memo  [384];

	char buf[1024];
	char *cgi_head = "Content-Type: text/html\r\n\r\n";

	if(argc < 2){
		print("This program needs args\n");
		return 1;
	}

	print(cgi_head);

	get_cgi_value(argv[1], "year"  ,   year, sizeof(year));
	get_cgi_value(argv[1], "month" ,  month, sizeof(month));
	get_cgi_value(argv[1], "date"  ,   date, sizeof(date));
	get_cgi_value(argv[1], "money" ,  money, sizeof(money));
	get_cgi_value(argv[1], "target", target, sizeof(target));
	get_cgi_value(argv[1], "place" ,  place, sizeof(place));
	get_cgi_value(argv[1], "memo"  ,   memo, sizeof(memo));


	//             |    |    |    |     |     |       |       |
	sprintf(buf, "%d\t%4s\t%2s\t%2s\t%10s\t\"%s\"\t\"%s\"\t\"%s\"\n",
		time(), year, month, date, money, target, place, memo);

	B fd;
	if( (fd=open(EXPENSE_FILE, O_WRONLY)) < 0 ){
		fd = creat(EXPENSE_FILE, 0777);
	}

	if(fd >= 0){
		lseek(fd, 0, SEEK_END);

		write(fd, buf, strlen(buf));
		
		close(fd);
	}

	
	print("<html><SCRIPT LANGUAGE=\"JavaScript\">history.go(-1);</SCRIPT></html>");

	return 0;
}


