#include "plugin.h"

#define MAX_VOLUME	0x05		// ق傫
#define MIN_VOLUME	0x80		


int main(int argc, char **argv){
	char buf[128];
	W vol;

	if(argc < 2){
		vol = vs1011e_getVolume();
		sprintf(buf, "Volume %d:%d \r\n", vol >> 8, vol&0xff);
		print(buf);
		return 0;
	}

	sscanf(argv[1], "%d", &vol);

	vol = -vol + (vs1011e_getVolume()&0xff);

	if( vol < MAX_VOLUME ) vol = MAX_VOLUME;
	if( vol > MIN_VOLUME ) vol = MIN_VOLUME;

	vs1011e_setVolume( vol | (vol<<8) );

	vol = vs1011e_getVolume();
	sprintf(buf, "Volume %d:%d \r\n", vol >> 8, vol&0xff);
	print(buf);

	return 0;
}


