#include "../sysinfo/src/incl/plugin.h"
#include "../sysinfo/src/incl/3069S.H"

#define EXTIO_DDRA   (*(volatile unsigned char   *)0x600000) /* P1DDR Address*/
#define EXTIO_DRA    (*(volatile unsigned char   *)0x600001) /* P1DDR Address*/
#define EXTIO_DDRB   (*(volatile unsigned char   *)0x600002) /* P1DDR Address*/
#define EXTIO_DRB    (*(volatile unsigned char   *)0x600003) /* P1DDR Address*/
#define EXTIO_DDRC   (*(volatile unsigned char   *)0x600004) /* P1DDR Address*/
#define EXTIO_DRC    (*(volatile unsigned char   *)0x600005) /* P1DDR Address*/

#define INTERVAL	(60*60)

#define MAX_VOLUME	0x05		// ق傫
#define MIN_VOLUME	0x80		

int main(int argc, char **argv){
	UW ipn, vol;

	if( (PADR.BYTE&0xf) != 0 ){
		syslog(5, " %d", PADR.BYTE&0xf);
	}else{
		return 0;
	}
/*
1-10 : 1-10 button

11   : mute

12   : vol +
13   : vol -

14   : ch +
15   : ch -
*/
	switch(PADR.BYTE&0xf){
		case 1: // S K Y . F M - Mostly Classical - Listen and Relax, it's good for you! www.sky.fm 
			getipbyname("scfire-nyk0l-1.stream.aol.com", &ipn);
			vs1011e_play_shoutcast(ipn, 80, "/stream/1006");
			break;
		case 2: // S K Y . F M - Smooth Jazz - the world's smoothest jazz 24 hours a day
			ipn = (64<<24) | (236<<16) | (99<<8) | 41;
			vs1011e_play_shoutcast(ipn, 80, "/stream/1010");
			break;
		case 7: //  k a w a i i - r a d i o | sr1 anime/japanese radio
			// 70.85.176.230:8000/
			ipn = (70<<24) | (85<<16) | (176<<8) | 230;
			vs1011e_play_shoutcast(ipn, 8000, "/");
			break;
		case 10: // 
			vs1011e_autoplay("/mp3");
			break;
		case 12: // volume up
			vol = -5 + (vs1011e_getVolume()&0xff);

			if( vol < MAX_VOLUME ) vol = MAX_VOLUME;
			if( vol > MIN_VOLUME ) vol = MIN_VOLUME;

			vs1011e_setVolume( vol | (vol<<8) );
			break;
		case 13: // volume down
			vol = 5 + (vs1011e_getVolume()&0xff);

			if( vol < MAX_VOLUME ) vol = MAX_VOLUME;
			if( vol > MIN_VOLUME ) vol = MIN_VOLUME;

			vs1011e_setVolume( vol | (vol<<8) );
			break;
		case 11: // mute 
			vs1011e_pause();
			break;
		case 14: // ch + 
			vs1011e_skip();
			break;
		case 15: // ch - 
			vs1011e_stop();
			break;
	}

	return 0;
}


