#include "../sysinfo/src/incl/plugin.h"
#include "../sysinfo/src/incl/3069S.H"

// vԊu(sec)
#define INTERVAL	(10*60)

#define LX_LOG		"/sens_lx.log"
#define TP_LOG		"/sens_tp.log"

UW get_lx(void){
	UW dat;

	dat = get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat += get_ad_value(1)>>6;
	dat /= 5;

	// 200lx : 100uA  -> 200lx : 100mV => 2000 [lx/V]

	// ŌvZ
	//    dat*5/1024 [V] * 2000 [lx/V]
	dat = (dat * 5 * 2000) / 1024;

	return dat;
}

UW get_tp(void){
	UW dat;

	dat = get_ad_value(0)>>6;
	dat += get_ad_value(0)>>6;
	dat += get_ad_value(0)>>6;
	dat += get_ad_value(0)>>6;
	dat += get_ad_value(0)>>6;
	dat /= 5;

	// _ȉ2܂ŌvZ (25.25x ->2525)
	//    (dat*5/1024 [V] / 0.1 [V/]) * 100
	dat = (dat * 5000) / 1024;
/*
	dat += 5;	// ľܓ
*/

	return dat;
}

int main(int argc, char **argv){
	static UW nexttim = 0;
	UW tim;
	B fd;
	B buf[64];

	tim = time();
	if( tim > nexttim ){
		if(nexttim == 0) nexttim = tim;

		nexttim += INTERVAL;
		
		//--------------------------------------------------
		if( (fd = open(LX_LOG, O_WRONLY)) < 0 ){
			fd = creat(LX_LOG, 0777);
		}
		if( fd >= 0 ){
			lseek(fd, 0, SEEK_END);

			sprintf(buf,"%d %d\n", tim, get_lx());
			write(fd, buf, strlen(buf));
			close(fd);
		}
		//--------------------------------------------------

		//--------------------------------------------------
		if( (fd = open(TP_LOG, O_WRONLY)) < 0 ){
			fd = creat(TP_LOG, 0777);
		}
		if( fd >= 0 ){
			lseek(fd, 0, SEEK_END);

			sprintf(buf,"%d %d\n", tim, get_tp());
			write(fd, buf, strlen(buf));
			close(fd);
		}
		//--------------------------------------------------
	}

	return 0;
}


