#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatbase.h"
#include "fatdesc.h"


/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;



/*


:
	pathname : Jt@C
	mode     : t@C̑ݒ肷
	           0777 ȂUNIXł̃ANZX̃[hwB
	           ł user ̎ŵݎQƂB܂A
	           0733 ł 0700 ̕QƂăt@C̑肷B
	           
	           r (0400) : HIDDEN tO
	           w (0200) : READ_ONLY tO
	           x (0100) : FATɑΉ鑮Ȃ

s -1 
0ȏ̃t@CfBXNv^Ԃ

*/
B creat(const char *pathname, UH mode){

	DirEntryPos filepos, parentpos;
	UB attr, buf[512];
	UW cluster;
	B ret = -1;

	if(*pathname=='/') pathname++;

	wai_sem( FAT_SEM );


	if( lookUpDirEntry(pathname, LOOKUP_DIRENTRY_CREAT, buf, &filepos, &parentpos) < 0 ) goto err_exit;

	if( filepos.isValid ){
		attr = getAttrAtDirEntry( (DirEntry *)(buf+(filepos.offset<<5)) );

		// łɃt@CAREAD only 
		if( attr&ATTR_READ_ONLY ) goto err_exit;

		cluster = getClusterAtDirEntry( (DirEntry *)&buf[(filepos.offset<<5)] );

		syslog(LOG_NOTICE, "creat:%d: file %s found", __LINE__, pathname);

		// Ώۃt@CǂݎĂ΁AVNODEerasetO𗧂ĂĂ
		// Ώۃt@CǂݎĂȂȂ΁ANX^܂ŊJ
		if( markEraseInVNode(filepos.cluster, filepos.sector, (filepos.offset<<5), cluster) < 0 ){
			if( 0 != freeClusterChain(cluster)){
				syslog(LOG_NOTICE, "creat:%d: failed to free a cluster chain (started at %d)", __LINE__, cluster);
			}
		}
	}else{
		syslog(LOG_NOTICE, "creat:%d: file allocated (DirEntry cluster:%d, sector:%d, offset:%d)", __LINE__, filepos.cluster, filepos.sector, filepos.offset);
	}

	attr = 0;
	if(!(mode&0400)) attr |= 0x02;  // r (0400) : HIDDEN tO
	if(!(mode&0200)) attr |= 0x01;  // w (0200) : READ_ONLY tO


	setDirectryEntry(
		(DirEntry *)&buf[filepos.offset<<5],	// fBNgGg
		DE_CHANGE_ATTR | DE_CHANGE_CLUSTER | DE_CHANGE_SIZE |		// 
		DE_CHANGE_CRETIME | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,
		NULL,			// t@C	(t@ClookupDirEntryŐݒ肳)
		attr,			// Attribute 
		0,			// cluster
		0);			// Size

	if( 0 != writeSector(filepos.cluster, filepos.sector, buf) ) goto err_exit;



	//  fd Ȃ -1 ݒ肳
	if( (ret = lookupFreeFD()) < 0 ) goto err_exit;

	//        fd,    Flags, offset,      de_cluster,      de_sector,           de_offset,  dir entry
	settingFD( ret, O_WRONLY,      0, filepos.cluster, filepos.sector, (filepos.offset<<5), (DirEntry *)(buf+(filepos.offset<<5)));


	// t@CfBNgɂď݁EANZXXV
	// ȂƁAt@CWindowsXPŃA[JCu̃t@CɂȂ悤
	// [gfBNgł͕sKv
	if(parentpos.isValid){
		if( 0 != readSector(parentpos.cluster, parentpos.sector, buf) ) goto err_exit;

		setDirectryEntry(
			(DirEntry *)&buf[parentpos.offset<<5],			// fBNgGg
			DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,		// 
			NULL,			// t@C
			0,			// Attribute 
			0,			// cluster
			0);			// Size

		if( 0 != writeSector(parentpos.cluster, parentpos.sector, buf) ) goto err_exit;
	}

err_exit:
	sig_sem( FAT_SEM );
	return ret;			// ret -1ŏĂ
}


