#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdir.h"
#include "fatbase.h"
#include "mmc_access.h"


extern DIR		DIRM[];

extern UW rootCluster;


/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;



/*
t@CT̓Ot@Cl[ɑΉĂȂB




:
	pathname : JfBNgB
	           I["/"ł͂ȂB
	           "/etc/" ł͊JA"/etc"ƂKvB
                   A"/"̏ꍇ́Â܂܂ł悢B

߂l: fBNgꍇɂDIR\̂ւ̃|C^ԂB
        sꍇɂNULLԂB
	(fBNg݂ȂꍇAfBNgɓǂݎ葮ꍇȂǂ)

*/
DIR *opendir(const char *pathname){

	char nname[12];
	UW de_cluster = rootCluster;	// fBNgGg̃NX^
	UW old_de_cluster;
	UH rd, old_rd;
	B  isDir, de_end;
	UB j, x, attr, tmp[512];

	nname[11] = '\0';
	
	if(*pathname=='/') pathname++;
	
	wai_sem( FAT_SEM );

	if( card_status & (MMC_CARD_NOTINSERTED | MMC_CARD_NOT_INIT | MMC_CARD_NOT_FSINIT) ) goto err_exit;

	// [gfBNg̏ꍇ
	if( *pathname == '\0' ){ de_cluster = rootCluster; goto exit; }

restart:

	pathname = getCurDirName(pathname, nname, &isDir);

	de_end = 0;
	rd     = 0;
	do{
		old_de_cluster = de_cluster;
		old_rd         = rd;

		// ̍s de_cluster, rd ̎QƐ悪1secterɈړ
		if( (de_end = readCluster(&de_cluster, &rd, tmp)) < 0 ) goto err_exit;

		for(j=0; j<16; j++){
			// 󂾂ApĂȂt@C΂
			if( 0 == tmp[(j<<5)] || 0x05 == tmp[(j<<5)] || 0xe5 == tmp[(j<<5)]) continue;

			// fBNg`FbN
			// (fBNgłȂ͔̂΂)
			attr = getAttrAtDirEntry( (DirEntry *)(tmp+(j<<5)) );
			if(! (attr&(1<<4)) ) continue;

			// fBNg`FbN
			if( 0 != strncmp2(nname, (char *)&(tmp[j<<5]), 11) ) continue;

			// ǂݍ݉\ŊJ悤ƂAHidden 
			if( (!isDir) && (attr&0x02) ) goto err_exit;

			de_cluster = getClusterAtDirEntry( (DirEntry *)(tmp+(j<<5)) );

			syslog(LOG_NOTICE, "opendir:%d: %s found at cluster %d", __LINE__, nname, de_cluster);

			if(isDir) goto restart;
			else      goto exit;
		}
	}while(!de_end);
err_exit:

	sig_sem( FAT_SEM );
	return NULL;
exit:
	
	
	for(x=0; x < N_DIR; x++){
		if(! DIRM[x].isValid) break;
	}
	if(x == N_DIR){ goto err_exit; }

	DIRM[x].isValid = 1;
	DIRM[x].offset  = 0;
	DIRM[x].cluster = de_cluster;


	sig_sem( FAT_SEM );
	return &(DIRM[x]);
}

