#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdesc.h"
#include "fatbase.h"
#include "mmc_access.h"


extern FileDesc	FD[];

/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;

extern UW secPerCluster;

/*

fd ő count oCgǂݏoAbufɊi[B

߂l: ꍇɂ͓ǂݍ񂾃oCgԂBAt@C̏Ił0ɂȂB
	t@Cʒu͂̐i߂(lseek)B
	t@C̍Ōɋ߂ꍇɂ́Acount߂lɂȂ邱ƂB
	G[̏ꍇ -1 ԂB
*/
W read(UB fd, UB *buf, W count){
	UB tmp[512];
	W  k, size, byte;
	UW cluster, depth;
	UH sec;
	
	if( fd >= N_FILE_DESCRIPTER ) return -1;
	if(count < 0) return -1;
	if( card_status & (MMC_CARD_NOTINSERTED | MMC_CARD_NOT_INIT | MMC_CARD_NOT_FSINIT) ) return -1;

	wai_sem( FAT_SEM );

	if(FD[fd].isValid == 0 || FD[fd].flags == O_WRONLY){
		count = -1;
		goto exit;
	}


	cluster = FD[fd].v->cluster;
	size    = FD[fd].v->size;

//	syslog(LOG_NOTICE, "read (fd %d): File size %d, cluster %d, offset %d", fd, size, cluster, FD[fd].offset);


	// ItZbgt@CI[ɂꍇ
	if( FD[fd].offset >= size ){ count = 0; goto exit; }
	
	// ۂ̓ǂݎoCg
	count = (FD[fd].offset+count > size) ? size - FD[fd].offset : count;
	
	// ǂݎ擪̈ʒu
	depth  = (FD[fd].offset>>9) / secPerCluster;
	sec    = (FD[fd].offset>>9) % secPerCluster;
	byte   = FD[fd].offset & 0x1ff;

	// ǂݎ擪NX^T
	if( depth == FD[fd].v->cluster_depth ){
		cluster = FD[fd].v->cluster_cache;
	}else{
		if( depth > FD[fd].v->cluster_depth ){
			cluster = FD[fd].v->cluster_cache;
			for(k=FD[fd].v->cluster_depth; k < depth; k++){
				if( 1 == (cluster = lookup_nextcluster(cluster))){ count = -1; goto exit; }
			}
		}else{
			for(k=0; k < depth; k++){
				if( 1 == (cluster = lookup_nextcluster(cluster))){ count = -1; goto exit; }
			}
		}
		FD[fd].v->cluster_depth = depth;
		FD[fd].v->cluster_cache = cluster;
	}

	if( byte != 0 ){
		if( readCluster(&cluster, &sec, tmp) < 0 ){ count = -1; goto exit; }
	}

	for(k=0; k < count; k++){
		if( byte == 0 && (count-k) >= 512 ){
			if( readCluster(&cluster, &sec, buf) < 0 ){ count = -1; goto exit; }
			buf = ((UB *)buf)+512;
			// byte +=512;
			k += 511;
		}else{
			if( byte == 0 ){
				if( readCluster(&cluster, &sec, tmp) < 0 ){ count = -1; goto exit; }
			}
			*((UB *)buf)++ = tmp[byte++];
			if( byte == 512 ) byte = 0;
		}
	}

	FD[fd].offset += count;

exit:
	sig_sem( FAT_SEM );

	return count;
}


