#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdesc.h"
#include "fatbase.h"
#include "mmc_access.h"


/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;



/*



:
	pathname : 폜t@C

	p[~bV͖č폜

߂l:
	0As-1


*/
B unlink(const char *pathname){

	DirEntryPos filepos, parentpos;
	UB buf[512];
	UW cluster;
	B  ret = -1;
	UB fname[12];


	if(*pathname=='/') pathname++;

	wai_sem( FAT_SEM );

	if( lookUpDirEntry(pathname, LOOKUP_DIRENTRY_FILE, buf, &filepos, &parentpos) < 0 ) goto err_exit;


	cluster = getClusterAtDirEntry( (DirEntry *)(buf+(filepos.offset<<5)) );

	// Ώۃt@CǂݎĂ΁AVNODEerasetO𗧂ĂĂ
	// Ώۃt@CǂݎĂȂȂ΁ANX^܂ŊJ
	if( markEraseInVNode(filepos.cluster, filepos.sector, (filepos.offset<<5), cluster) < 0 ){
		if( 0 != freeClusterChain(cluster) ){
			syslog(LOG_NOTICE, "unlink:%d: failed to free a cluster chain (started at %d)", __LINE__, cluster);
		}
	}

	fname[0] = 0xe5;	// fBNgGg󂫂ɂ
	fname[1] = '\0';

	setDirectryEntry(
		(DirEntry *)&buf[filepos.offset<<5],	// fBNgGg
		DE_CHANGE_NAME | DE_CHANGE_ATTR | DE_CHANGE_CLUSTER | DE_CHANGE_SIZE |		// 
		DE_CHANGE_CRETIME | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,
		fname,			// t@C
		0,			// Attribute 
		0,			// cluster
		0);			// Size

	if( 0 != writeSector(filepos.cluster, filepos.sector, buf)) goto err_exit;

	ret = 0;

err_exit:

	sig_sem( FAT_SEM );

	return ret;
}
