#ifndef _FATDATATYPE_H_
#define _FATDATATYPE_H_

/*
t@C̍Œ('.'܂߂)
*/
#define NAME_MAX 12

/*
pX̍Œ

c:\......
255̂悤Ȃ̂ŁAC:̕ĈSW250
*/
#define PATH_MAX	250

// fBNgGg̑
#define ATTR_READ_ONLY		0x01
#define ATTR_HIDDEN		0x02
#define ATTR_SYSTEM		0x04
#define ATTR_VOLUME_ID		0x08
#define ATTR_DIRECTORY		0x10
#define ATTR_ARCHIVE		0x20

#define ATTR_LONG_NAME		0x0f


typedef struct DirEntry_t {
	UB	name[8];	/* file name */
	UB	extension[3];	/* file name extension */
	UB	attribute;	/* file attribute
				    ATTR_READ_ONLY	0x01
				    ATTR_HIDDEN		0x02
				    ATTR_SYSTEM		0x04
				    ATTR_VOLUME_ID	0x08
				    ATTR_DIRECTORY	0x10
				    ATTR_ARCHIVE	0x20

				    ATTR_LONG_NAME	0x0f */
	UB	reserved;	/* use NT or same OS */
	UB	createTimeMs;	/* VFAT Ŏgpt@C쐬10~b (0 ` 199) */
	UB	createTime[2];	/* VFAT Ŏgpt@C쐬(2bP)
				   bit  0- 4 ( time[0][4:0] )             : 2 bPʂ̕b(0-58) 0...29
				   bit  5-10 ( time[1][2:0], time[0][7:5]):                  0...59
				   bit 11-15 ( time[1][7:3] )             :                0...23
				*/
	UB	createDate[2];	/* VFAT Ŏgpt@C쐬t
				   bit 0- 4 ( date[0][3:0] )             :  (day of month) 1...31
				   bit 5- 8 ( date[1][0], date[0][7:4] ) :  (Jan=1)        1...12
				   bit 9-15 ( date[1][7:1] )             : N (1980N=0)     0...127
				*/
	UB	accessDate[2];	/* VFAT Ŏgpt@CEANZXt */
	UB	clusterHighWord[2];
				/* FAT32 ŎgpNX^ԍ̏ 16 bits 
				   (FAT12,16ł͏0) */
	UB	writeTime[2];
	UB 	writeDate[2];
	UB	cluster[2];	/* start cluster number */
	UB	fileSize[4];	/* file size in bytes (directory is always zero) */
} DirEntry;


#endif	/* of #ifndef _FATDATATYPE_H_ */
