#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fatdesc.h"
#include "fatbase.h"

/*

t@CfBXNv^

*/
FileDesc	FD[N_FILE_DESCRIPTER];


/*

vnode 
(FD̍ő吔pӂĂΑv)

*/
VNode		VNODE[N_FILE_DESCRIPTER];



/*
	fd ׂ close ̏ԂɂĂ
*/
void clearFD(void){
	B i;

	for(i=0; i < N_FILE_DESCRIPTER; i++){
		FD[i].isValid = 0;
	}
}
void clearVNODE(void){
	B i;
	
	for(i=0; i < N_FILE_DESCRIPTER; i++){
		VNODE[i].refcount = 0;
	}
}


/*
gp̃t@CfBXNv^T

߂lF
	ꍇ  :@0ȏ̒l
	Ȃꍇ:  -1
*/
B lookupFreeFD(void){
	B i;

	for(i=0; i < N_FILE_DESCRIPTER; i++){
		if(! FD[i].isValid) return i;
	}

	return -1;
}

/*



	fd		: ݒΏۂ̃t@CfBXNv^
	Flag		: open ̐ݒ
	Offset		: ItZbg
	De_cluster	: 
	De_sector	: 
	De_offset	: 
	de		: 

*/
void settingFD(B fd, W Flags, W Offset, UW De_cluster, UH De_sector, UH De_offset, DirEntry *de){
	UW cluster, tmp;
	UB i, unused;

	cluster = getClusterAtDirEntry(de);

//	syslog(LOG_NOTICE, "settingFD (fd %d): DirEntry cluster %d, sector %d, offset %d", fd, De_cluster,De_sector, De_offset);


	FD[fd].flags   = Flags;
	FD[fd].offset  = Offset;
	FD[fd].isValid = 1;
	
	for(i=0; i<N_FILE_DESCRIPTER; i++){
		tmp = VNODE[i].cluster;

		if( VNODE[i].refcount > 0 && cluster == tmp && 
		    VNODE[i].de_cluster == De_cluster &&
		    VNODE[i].de_sector  == De_sector  &&
		    VNODE[i].de_offset  == De_offset){
			VNODE[i].refcount ++;
			FD[fd].v = &VNODE[i];

			return;
		}

		if( VNODE[i].refcount == 0 ) unused = i;
	}

//	syslog(LOG_NOTICE, "alloc Vnode %d", unused);
	
	VNODE[unused].d             = *de;
	VNODE[unused].cluster       = cluster;
	VNODE[unused].size          =  ((UW)de->fileSize[0])      | (((UW)de->fileSize[1])<<8) |
	                              (((UW)de->fileSize[2])<<16) | (((UW)de->fileSize[3])<<24);
/*
	VNODE[unused].size          = ((UW)(de->fileSize[0]))     | ((UW)(de->fileSize[1]<<8)) |
	                              ((UW)(de->fileSize[2]<<16)) | ((UW)(de->fileSize[3]<<24));
*/
	VNODE[unused].de_cluster    = De_cluster;
	VNODE[unused].de_sector     = De_sector;
	VNODE[unused].de_offset     = De_offset;
	VNODE[unused].cluster_cache = cluster;
	VNODE[unused].cluster_depth = 0;
	VNODE[unused].refcount      = 1;
	VNODE[unused].erase         = 0;

	FD[fd].v = &VNODE[unused];
}




/*
Ŏw肵ƍvVNODE΁A
erase tO𗧂ĂB

߂l:
	erase tO𗧂Ăꍇ 1
	VNODE Ɉɍv̂Ȃꍇ -1 

*/
B markEraseInVNode(UW De_cluster, UH De_sector, UH De_offset, UH cluster){
	UB i;
	UH tmp;

	for(i=0; i<N_FILE_DESCRIPTER; i++){
		tmp = VNODE[i].cluster;

		if( VNODE[i].refcount > 0 && cluster == tmp && 
		    VNODE[i].de_cluster == De_cluster &&
		    VNODE[i].de_sector  == De_sector  &&
		    VNODE[i].de_offset  == De_offset){

			VNODE[i].de_cluster = 0;	// fBNgGg͍폜Ă
			VNODE[i].de_sector  = 0;
			VNODE[i].de_offset  = 0;

			VNODE[i].erase = 1;

			return 1;
		}
	}

	return -1;
}



