#include "incl/plugin.h"
#include "incl/3069S.H"


#define TEST_FILE	"/iobench.tst"
#define TEST_SIZE	(1024*80)		// byte 


int main(int argc, char **argv){
	char buf[3073];
	UW dat;
	B fd;
	UW i,j;
	UW t,t1,t2;
	UH bsize[] = {256,512,1024, 2048, 3072, 0};
	UH *psize;
	char *cgi_head = "Content-Type: text/html\r\n\r\n";


	print  (cgi_head);
	print  ("<html><head><title>I/Ox`}[N</title></head><body>");			// html body
	print  ("<center><div align=\"center\" style=\"width: 680px; color: #647484;\">");	//center div
	sprintf(buf, "<h2>I/Ox`}[N</h2><br>(%s)</div><hr>", TEST_FILE);			// -div
	print  (buf);
	print  ("<div align=\"left\" style=\"width: 480px; color: #647484;\">");		// div

	
	for(psize = bsize; *psize != 0; psize++){
		if( (fd = creat(TEST_FILE, 0777)) < 0 ){
			break;
		}

		j = TEST_SIZE / *psize;

		t = time();
		for(i=0; i<j; i++) write(fd, buf, *psize);
		t1 = time() - t;

		lseek(fd, 0, SEEK_SET);
		for(i=0; i<j; i++) read (fd, buf, *psize);
		t2 = time() - (t + t1);

		close(fd);
		unlink(TEST_FILE);

		sprintf(buf, "<br><h4>%d byte access<h4><br>", *psize);
		print(buf);
		sprintf(buf, "%d byte write : %d sec<br>", TEST_SIZE, t1);
		print(buf);
		sprintf(buf, "%d byte read  : %d sec<br>", TEST_SIZE, t2);
		print(buf);
	}
	
	



	print(" </div><hr></center></body></html>");						// -div -center -body -html

	return 0;
}

