#include <itron.h>

#include "tokenize.h"
#include "fat_api.h"



/*
obt@O̈ꕶǂݍ݁B

̊֐ read, lseek Ďg
֐őz肷錻݈ʒuƎۂ݈̌ʒu邽߁A
̂̊֐ł̌Ăяoł͗\ȂʂƂȂB
read, lseek ̌ďoɂ
pos=0 Ƃăobt@̓ej邱ƂKvłB
tɁÅ֐̌read ĂяoƂA
obt@Ỏeɂ錻݈ʒu̕ω͌A
\Ƃ̘AʂB


buf     : obt@
bufsize : obt@̃TCY

*/
UB getChar(UB *buf, UH bufsize, UH *pos, UH *valid, UB fd, B *c){

	if(*pos == 0){
		*valid = read(fd, buf, bufsize);
		// t@Č݈ʒu߂
		lseek( fd, -(*valid), 1);	// SEEK_CUR = 1
	}
	
	if( *valid > *pos ){
		*c = buf[*pos];
		*pos   = ((*pos)+1 == *valid) ? 0 : (*pos) + 1;
		// t@Č݈ʒui߂Ă
		lseek( fd, 1, 1);	// SEEK_CUR = 1

		return 1;
	}else{
		return 0;
	}
}



/*

͊
Ԃ͎ȂB

nextToken_m Ƃ͉͋KႤ̂Œ
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

comment : //   / * * /̃Rggp\
          // ɂ / *  * / ͖
          / *  * / ̃lXgs
num:  [0-9]+	(Ȃ...)
word: [_a-zA-Z][0-9_a-zA-Z]*
      \".*\"   ("̂\"ƋLq)

*/
UH nextToken(UB fd, UH *nval, B *sval, UB len){
	B c;
	H i;
	UB buf[32];
	UH pos=0, valid;

restart:

	do{
		if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;
	}while( c == ' ' || c=='\n' || c=='\r' || c=='\t' );

	if( c==0 ) return TT_EOF;

	if( c=='/' ){
		if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return c;

		if( c == '/' ){
			do{
				if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;
			}while( c != '\n' );
		}else if( c == '*' ){
			for( ; c != '/' ; ){
				do{
					if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;
				}while( c != '*' );

				if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;
			}
		}else{
			lseek( fd, -1, 1);	// SEEK_CUR = 1
			return '/';
		}
		goto restart;
	}


	if( c>='0' && c<='9' ){
		*nval = 0;

		do{
			*nval = (*nval)*10 + c - '0';
			if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) break;
		}while( c>='0' && c<='9');

		lseek( fd, -1, 1);	// SEEK_CUR = 1
		return TT_NUMBER;
	}
	
	if( c=='\"' ){
		i = 0;
		if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;

		do{
			if( c == '\\')
				if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;
			if( i < len-1 ) sval[i++] = c;
			if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) return TT_EOF;
		}while( c!= '\"' );

		sval[i] = '\0';

		return TT_WORD;
	}
	
	if( c=='_' || (c>='a' && c<='z') || (c>='A' && c<= 'Z') ){
		i = 0;

		do{
			if( i < len-1 ) sval[i++] = c;
			if( getChar(buf, sizeof(buf), &pos, &valid, fd, &c) == 0 ) break;
		}while( c=='_' || (c>='a' && c<='z') || (c>='A' && c<= 'Z') || (c>='0' && c<='9') );

		sval[i] = '\0';

		lseek( fd, -1, 1);	// SEEK_CUR = 1
//		printf("test : %d\n", test);

		return TT_WORD;
	}
	
	
	return c;
}


/*

͊
Ԃ͎ȂB

nextToken Ƃ͉͋KႤ̂Œ
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


mem  : ͂镶i[
nmem : ̎͂̈ʒuԒni[

num:  [0-9]+	(Ȃ...)
word: [_a-zA-Z][0-9_a-zA-Z]*

*/
UH nextToken_m(UB *mem, UB **nmem, UH *nval, B *sval, UB len){
	B c;
	H i;

	do{
		if( (c=(*mem++)) == '\0' ){ *nmem = mem; return TT_EOF; }
	}while( c == ' ' || c=='\n' || c=='\r' || c=='\t' );

	if( c==0 ){ *nmem = mem; return TT_EOF; }

	if( c>='0' && c<='9' ){
		*nval = 0;

		do{
			*nval = (*nval)*10 + c - '0';
			if( (c=(*mem++)) == '\0' ) break;
		}while( c>='0' && c<='9');

		*nmem = --mem;
		return TT_NUMBER;
	}
	
	if( c=='_' || (c>='a' && c<='z') || (c>='A' && c<= 'Z') ){
		i = 0;

		do{
			if( i < len-1 ) sval[i++] = c;
			if( (c=(*mem++)) == '\0' ) break;
		}while( c=='_' || (c>='a' && c<='z') || (c>='A' && c<= 'Z') || (c>='0' && c<='9') );

		sval[i] = '\0';

		*nmem = --mem;

		return TT_WORD;
	}
	
	*nmem = mem;
	return c;
}

